import threading

class TimeoutLock:
    def __init__(self, interval: int):
        self._interval = interval
        self._locked = False
        self._timer = None

    def lock(self):
        self._locked = True
        if self._timer is not None and self._timer.is_alive():
            self._timer.cancel()
        self._timer = threading.Timer(self._interval, self._unlock).start()

    def _unlock(self):
        self._locked = False

    @property
    def is_locked(self):
        return self._locked
